Index: /NEMO/trunk/src/OCE/ISF/isfcpl.F90
===================================================================
--- /NEMO/trunk/src/OCE/ISF/isfcpl.F90	(revision 13294)
+++ /NEMO/trunk/src/OCE/ISF/isfcpl.F90	(revision 13295)
@@ -194,5 +194,5 @@
          !
          zdssmask(:,:) = ssmask(:,:) - zssmask0(:,:)
-         DO_2D_00_00
+         DO_2D( 0, 0, 0, 0 )
             jip1=ji+1; jim1=ji-1;
             jjp1=jj+1; jjm1=jj-1;
@@ -317,5 +317,5 @@
             zdmask(:,:) = tmask(:,:,jk) - ztmask0(:,:,jk);
             !
-            DO_2D_00_00
+            DO_2D( 0, 0, 0, 0 )
                jip1=ji+1; jim1=ji-1;
                jjp1=jj+1; jjm1=jj-1;
@@ -378,5 +378,5 @@
       ! -----------------------------------------------------------------------------------------
       ! case we open a cell but no neigbour cells available to get an estimate of T and S
-      DO_3D_11_11( 1,jpk-1 )
+      DO_3D( 1, 1, 1, 1, 1,jpk-1 )
          IF (tmask(ji,jj,jk) == 1._wp .AND. ts(ji,jj,jk,2,Kmm) == 0._wp)              &
             &   CALL ctl_stop('STOP', 'failing to fill all new weet cell,     &
@@ -418,5 +418,5 @@
       DO jk = 1, jpk                                 ! Horizontal slab
          ! 1.1: get volume flux before coupling (>0 out)
-         DO_2D_00_00
+         DO_2D( 0, 0, 0, 0 )
             zqvolb(ji,jj,jk) =    &
                &  (   e2u(ji  ,jj  ) * ze3u_b(ji  ,jj  ,jk) * uu(ji  ,jj  ,jk,Kmm)      &
@@ -433,5 +433,5 @@
          vv(:,:,jk,Kmm) = vv(:,:,jk,Kmm) * vmask(:,:,jk)
          ! compute volume flux divergence after coupling
-         DO_2D_00_00
+         DO_2D( 0, 0, 0, 0 )
             zqvoln(ji,jj,jk) =   &
                &  (   e2u(ji  ,jj  ) * e3u(ji  ,jj  ,jk,Kmm) * uu(ji  ,jj  ,jk,Kmm)    &
@@ -449,5 +449,5 @@
       ! 2.0: include the contribution of the vertical velocity in the volume flux correction
       !
-      DO_2D_00_00
+      DO_2D( 0, 0, 0, 0 )
          !
          ikt = mikt(ji,jj)
Index: /NEMO/trunk/src/OCE/ISF/isfdiags.F90
===================================================================
--- /NEMO/trunk/src/OCE/ISF/isfdiags.F90	(revision 13294)
+++ /NEMO/trunk/src/OCE/ISF/isfdiags.F90	(revision 13295)
@@ -101,5 +101,5 @@
       zvar3d(:,:,:) = 0._wp
       !
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          ikt = ktop(ji,jj)
          ikb = kbot(ji,jj)
Index: /NEMO/trunk/src/OCE/ISF/isfhdiv.F90
===================================================================
--- /NEMO/trunk/src/OCE/ISF/isfhdiv.F90	(revision 13294)
+++ /NEMO/trunk/src/OCE/ISF/isfhdiv.F90	(revision 13295)
@@ -100,5 +100,5 @@
       !
       ! update divergence at each level affected by ice shelf top boundary layer
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          ikt = ktop(ji,jj)
          ikb = kbot(ji,jj)
Index: /NEMO/trunk/src/OCE/ISF/isfload.F90
===================================================================
--- /NEMO/trunk/src/OCE/ISF/isfload.F90	(revision 13294)
+++ /NEMO/trunk/src/OCE/ISF/isfload.F90	(revision 13295)
@@ -94,5 +94,5 @@
       !                                !- Surface value + ice shelf gradient
       pisfload(:,:) = 0._wp                       ! compute pressure due to ice shelf load 
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          ikt = mikt(ji,jj)
          !
Index: /NEMO/trunk/src/OCE/ISF/isftbl.F90
===================================================================
--- /NEMO/trunk/src/OCE/ISF/isftbl.F90	(revision 13294)
+++ /NEMO/trunk/src/OCE/ISF/isftbl.F90	(revision 13295)
@@ -78,5 +78,5 @@
          ! compute tbl property at T point
          pvarout(1,:) = 0._wp
-         DO_2D_11_01
+         DO_2D( 1, 1, 0, 1 )
             pvarout(ji,jj) = 0.5_wp * (zvarout(ji,jj) + zvarout(ji-1,jj))
          END_2D
@@ -99,5 +99,5 @@
          ! pvarout is an averaging of wet point
          pvarout(:,1) = 0._wp
-         DO_2D_01_11
+         DO_2D( 0, 1, 1, 1 )
             pvarout(ji,jj) = 0.5_wp * (zvarout(ji,jj) + zvarout(ji,jj-1))
          END_2D
@@ -138,5 +138,5 @@
       !
       ! compute tbl top.bottom level and thickness
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          !
          ! tbl top/bottom indices initialisation
@@ -176,5 +176,5 @@
       !
       ! get htbl
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          !
          ! tbl top/bottom indices initialisation
@@ -193,5 +193,5 @@
       !
       ! get pfrac
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          !
          ! tbl top/bottom indices initialisation
@@ -227,5 +227,5 @@
       !
       ! get ktbl
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          !
          ! determine the deepest level influenced by the boundary layer
@@ -261,5 +261,5 @@
       ! test: this routine run with pdep = 0 should return 1
       !
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          ! comput ktop
          ikt = 2
Index: /NEMO/trunk/src/OCE/LDF/ldfc1d_c2d.F90
===================================================================
--- /NEMO/trunk/src/OCE/LDF/ldfc1d_c2d.F90	(revision 13294)
+++ /NEMO/trunk/src/OCE/LDF/ldfc1d_c2d.F90	(revision 13295)
@@ -80,5 +80,5 @@
             pah1(:,:,jk) = pahs1(:,:) * (  zratio + zc * ( 1._wp + TANH( - ( gdept_0(:,:,jk) - zh ) * zw) )  )
          END DO
-         DO_3DS_10_10( jpkm1, 1, -1 )
+         DO_3DS( 1, 0, 1, 0, jpkm1, 1, -1 )
             zdep2 = (  gdept_0(ji,jj+1,jk) + gdept_0(ji+1,jj+1,jk)   &
                &     + gdept_0(ji,jj  ,jk) + gdept_0(ji+1,jj  ,jk)  ) * r1_4
@@ -88,5 +88,5 @@
          !
       CASE( 'TRA' )                     ! U- and V-points (zdep1 & 2 are an approximation in zps-coord.)
-         DO_3DS_10_10( jpkm1, 1, -1 )
+         DO_3DS( 1, 0, 1, 0, jpkm1, 1, -1 )
             zdep1 = (  gdept_0(ji,jj,jk) + gdept_0(ji+1,jj,jk)  ) * 0.5_wp
             zdep2 = (  gdept_0(ji,jj,jk) + gdept_0(ji,jj+1,jk)  ) * 0.5_wp
@@ -135,10 +135,10 @@
       !
       CASE( 'DYN' )                       ! T- and F-points
-         DO_2D_11_11
+         DO_2D( 1, 1, 1, 1 )
             pah1(ji,jj,1) = pUfac * MAX( e1t(ji,jj) , e2t(ji,jj) )**knn
             pah2(ji,jj,1) = pUfac * MAX( e1f(ji,jj) , e2f(ji,jj) )**knn
          END_2D
       CASE( 'TRA' )                       ! U- and V-points
-         DO_2D_11_11
+         DO_2D( 1, 1, 1, 1 )
             pah1(ji,jj,1) = pUfac * MAX( e1u(ji,jj), e2u(ji,jj) )**knn
             pah2(ji,jj,1) = pUfac * MAX( e1v(ji,jj), e2v(ji,jj) )**knn
Index: /NEMO/trunk/src/OCE/LDF/ldfdyn.F90
===================================================================
--- /NEMO/trunk/src/OCE/LDF/ldfdyn.F90	(revision 13294)
+++ /NEMO/trunk/src/OCE/LDF/ldfdyn.F90	(revision 13295)
@@ -311,5 +311,5 @@
             IF( ierr /= 0 )   CALL ctl_stop( 'STOP', 'ldf_dyn_init: failed to allocate Smagorinsky arrays')
             !
-            DO_2D_11_11
+            DO_2D( 1, 1, 1, 1 )
                esqt(ji,jj) = ( 2._wp * e1e2t(ji,jj) / ( e1t(ji,jj) + e2t(ji,jj) ) )**2 
                esqf(ji,jj) = ( 2._wp * e1e2f(ji,jj) / ( e1f(ji,jj) + e2f(ji,jj) ) )**2 
@@ -368,5 +368,5 @@
          IF( ln_dynldf_lap   ) THEN        ! laplacian operator : |u| e /12 = |u/144| e
             DO jk = 1, jpkm1
-               DO_2D_00_00
+               DO_2D( 0, 0, 0, 0 )
                   zu2pv2_ij    = uu(ji  ,jj  ,jk,Kbb) * uu(ji  ,jj  ,jk,Kbb) + vv(ji  ,jj  ,jk,Kbb) * vv(ji  ,jj  ,jk,Kbb)
                   zu2pv2_ij_m1 = uu(ji-1,jj  ,jk,Kbb) * uu(ji-1,jj  ,jk,Kbb) + vv(ji  ,jj-1,jk,Kbb) * vv(ji  ,jj-1,jk,Kbb)
@@ -374,5 +374,5 @@
                   ahmt(ji,jj,jk) = SQRT( (zu2pv2_ij + zu2pv2_ij_m1) * r1_288 ) * zemax * tmask(ji,jj,jk)      ! 288= 12*12 * 2
                END_2D
-               DO_2D_10_10
+               DO_2D( 1, 0, 1, 0 )
                   zu2pv2_ij_p1 = uu(ji  ,jj+1,jk, Kbb) * uu(ji  ,jj+1,jk, Kbb) + vv(ji+1,jj  ,jk, Kbb) * vv(ji+1,jj  ,jk, Kbb)
                   zu2pv2_ij    = uu(ji  ,jj  ,jk, Kbb) * uu(ji  ,jj  ,jk, Kbb) + vv(ji  ,jj  ,jk, Kbb) * vv(ji  ,jj  ,jk, Kbb)
@@ -383,5 +383,5 @@
          ELSEIF( ln_dynldf_blp ) THEN      ! bilaplacian operator : sqrt( |u| e^3 /12 ) = sqrt( |u/144| e ) * e
             DO jk = 1, jpkm1
-               DO_2D_00_00
+               DO_2D( 0, 0, 0, 0 )
                   zu2pv2_ij    = uu(ji  ,jj  ,jk,Kbb) * uu(ji  ,jj  ,jk,Kbb) + vv(ji  ,jj  ,jk,Kbb) * vv(ji  ,jj  ,jk,Kbb)
                   zu2pv2_ij_m1 = uu(ji-1,jj  ,jk,Kbb) * uu(ji-1,jj  ,jk,Kbb) + vv(ji  ,jj-1,jk,Kbb) * vv(ji  ,jj-1,jk,Kbb)
@@ -389,5 +389,5 @@
                   ahmt(ji,jj,jk) = SQRT(  SQRT( (zu2pv2_ij + zu2pv2_ij_m1) * r1_288 ) * zemax  ) * zemax * tmask(ji,jj,jk)
                END_2D
-               DO_2D_10_10
+               DO_2D( 1, 0, 1, 0 )
                   zu2pv2_ij_p1 = uu(ji  ,jj+1,jk, Kbb) * uu(ji  ,jj+1,jk, Kbb) + vv(ji+1,jj  ,jk, Kbb) * vv(ji+1,jj  ,jk, Kbb)
                   zu2pv2_ij    = uu(ji  ,jj  ,jk, Kbb) * uu(ji  ,jj  ,jk, Kbb) + vv(ji  ,jj  ,jk, Kbb) * vv(ji  ,jj  ,jk, Kbb)
@@ -412,5 +412,5 @@
             DO jk = 1, jpkm1
                !
-               DO_2D_00_00
+               DO_2D( 0, 0, 0, 0 )
                   zdb =    ( uu(ji,jj,jk,Kbb) * r1_e2u(ji,jj) -  uu(ji-1,jj,jk,Kbb) * r1_e2u(ji-1,jj) )  &
                        &                      * r1_e1t(ji,jj) * e2t(ji,jj)                           &
@@ -420,5 +420,5 @@
                END_2D
                !
-               DO_2D_10_10
+               DO_2D( 1, 0, 1, 0 )
                   zdb =   (  uu(ji,jj+1,jk,Kbb) * r1_e1u(ji,jj+1) -  uu(ji,jj,jk,Kbb) * r1_e1u(ji,jj) )  &
                        &                        * r1_e2f(ji,jj)   * e1f(ji,jj)                       &
@@ -434,5 +434,5 @@
             DO jk = 1, jpkm1
               !
-               DO_2D_00_00
+               DO_2D( 0, 0, 0, 0 )
                   !
                   zu2pv2_ij    = uu(ji  ,jj  ,jk,Kbb) * uu(ji  ,jj  ,jk,Kbb) + vv(ji  ,jj  ,jk,Kbb) * vv(ji  ,jj  ,jk,Kbb)
@@ -448,5 +448,5 @@
                END_2D
                !
-               DO_2D_10_10
+               DO_2D( 1, 0, 1, 0 )
                   !
                   zu2pv2_ij_p1 = uu(ji  ,jj+1,jk, kbb) * uu(ji  ,jj+1,jk, kbb) + vv(ji+1,jj  ,jk, kbb) * vv(ji+1,jj  ,jk, kbb)
@@ -471,8 +471,8 @@
             !                          ! effective default limits are 1/12 |U|L^3 < B_hm < 1//(32*2dt) L^4
             DO jk = 1, jpkm1
-               DO_2D_00_00
+               DO_2D( 0, 0, 0, 0 )
                   ahmt(ji,jj,jk) = SQRT( r1_8 * esqt(ji,jj) * ahmt(ji,jj,jk) )
                END_2D
-               DO_2D_10_10
+               DO_2D( 1, 0, 1, 0 )
                   ahmf(ji,jj,jk) = SQRT( r1_8 * esqf(ji,jj) * ahmf(ji,jj,jk) )
                END_2D
Index: /NEMO/trunk/src/OCE/LDF/ldfslp.F90
===================================================================
--- /NEMO/trunk/src/OCE/LDF/ldfslp.F90	(revision 13294)
+++ /NEMO/trunk/src/OCE/LDF/ldfslp.F90	(revision 13295)
@@ -137,10 +137,10 @@
       zwz(:,:,:) = 0._wp
       !
-      DO_3D_10_10( 1, jpk )
+      DO_3D( 1, 0, 1, 0, 1, jpk )
          zgru(ji,jj,jk) = umask(ji,jj,jk) * ( prd(ji+1,jj  ,jk) - prd(ji,jj,jk) )
          zgrv(ji,jj,jk) = vmask(ji,jj,jk) * ( prd(ji  ,jj+1,jk) - prd(ji,jj,jk) )
       END_3D
       IF( ln_zps ) THEN                           ! partial steps correction at the bottom ocean level
-         DO_2D_10_10
+         DO_2D( 1, 0, 1, 0 )
             zgru(ji,jj,mbku(ji,jj)) = gru(ji,jj)
             zgrv(ji,jj,mbkv(ji,jj)) = grv(ji,jj)
@@ -148,5 +148,5 @@
       ENDIF
       IF( ln_zps .AND. ln_isfcav ) THEN           ! partial steps correction at the bottom ocean level
-         DO_2D_10_10
+         DO_2D( 1, 0, 1, 0 )
             IF( miku(ji,jj) > 1 )   zgru(ji,jj,miku(ji,jj)) = grui(ji,jj) 
             IF( mikv(ji,jj) > 1 )   zgrv(ji,jj,mikv(ji,jj)) = grvi(ji,jj)
@@ -173,5 +173,5 @@
       !
       IF ( ln_isfcav ) THEN
-         DO_2D_00_00
+         DO_2D( 0, 0, 0, 0 )
             zslpml_hmlpu(ji,jj) = uslpml(ji,jj) / ( MAX(hmlpt  (ji,jj), hmlpt  (ji+1,jj  ), 5._wp) &
                &                                  - MAX(risfdep(ji,jj), risfdep(ji+1,jj  )       ) ) 
@@ -180,5 +180,5 @@
          END_2D
       ELSE
-         DO_2D_00_00
+         DO_2D( 0, 0, 0, 0 )
             zslpml_hmlpu(ji,jj) = uslpml(ji,jj) / MAX(hmlpt(ji,jj), hmlpt(ji+1,jj  ), 5._wp)
             zslpml_hmlpv(ji,jj) = vslpml(ji,jj) / MAX(hmlpt(ji,jj), hmlpt(ji  ,jj+1), 5._wp)
@@ -186,5 +186,5 @@
       END IF
 
-      DO_3D_00_00( 2, jpkm1 )
+      DO_3D( 0, 0, 0, 0, 2, jpkm1 )
          !                                      ! horizontal and vertical density gradient at u- and v-points
          zau = zgru(ji,jj,jk) * r1_e1u(ji,jj)
@@ -233,5 +233,5 @@
       !                                            !* horizontal Shapiro filter
       DO jk = 2, jpkm1
-         DO_2D_00_00
+         DO_2D( 0, 0, 0, 0 )
             uslp(ji,jj,jk) = z1_16 * (        zwz(ji-1,jj-1,jk) + zwz(ji+1,jj-1,jk)      &
                &                       +      zwz(ji-1,jj+1,jk) + zwz(ji+1,jj+1,jk)      &
@@ -260,5 +260,5 @@
          END DO
          !                                        !* decrease along coastal boundaries
-         DO_2D_00_00
+         DO_2D( 0, 0, 0, 0 )
             uslp(ji,jj,jk) = uslp(ji,jj,jk) * ( umask(ji,jj+1,jk) + umask(ji,jj-1,jk  ) ) * 0.5_wp   &
                &                            * ( umask(ji,jj  ,jk) + umask(ji,jj  ,jk+1) ) * 0.5_wp
@@ -272,5 +272,5 @@
       ! ===========================      | wslpj = mij( d/dj( prd ) / d/dz( prd )
       !
-      DO_3D_00_00( 2, jpkm1 )
+      DO_3D( 0, 0, 0, 0, 2, jpkm1 )
          !                                  !* Local vertical density gradient evaluated from N^2
          zbw = zm1_2g * pn2 (ji,jj,jk) * ( prd (ji,jj,jk) + prd (ji,jj,jk-1) + 2. )
@@ -307,5 +307,5 @@
       !                                           !* horizontal Shapiro filter
       DO jk = 2, jpkm1
-         DO_2D_00_00
+         DO_2D( 0, 0, 0, 0 )
             zcofw = wmask(ji,jj,jk) * z1_16
             wslpi(ji,jj,jk) = (         zwz(ji-1,jj-1,jk) + zwz(ji+1,jj-1,jk)     &
@@ -338,5 +338,5 @@
          END DO
          !                                        !* decrease in vicinity of topography
-         DO_2D_00_00
+         DO_2D( 0, 0, 0, 0 )
             zck =   ( umask(ji,jj,jk) + umask(ji-1,jj,jk) )   &
                &  * ( vmask(ji,jj,jk) + vmask(ji,jj-1,jk) ) * 0.25
@@ -401,5 +401,5 @@
          !
          ip = jl   ;   jp = jl                ! guaranteed nonzero gradients ( absolute value larger than repsln)
-         DO_3D_10_10( 1, jpkm1 )
+         DO_3D( 1, 0, 1, 0, 1, jpkm1 )
             zdit = ( ts(ji+1,jj,jk,jp_tem,Kbb) - ts(ji,jj,jk,jp_tem,Kbb) )    ! i-gradient of T & S at u-point
             zdis = ( ts(ji+1,jj,jk,jp_sal,Kbb) - ts(ji,jj,jk,jp_sal,Kbb) )
@@ -413,5 +413,5 @@
          !
          IF( ln_zps .AND. l_grad_zps ) THEN     ! partial steps: correction of i- & j-grad on bottom
-            DO_2D_10_10
+            DO_2D( 1, 0, 1, 0 )
                iku  = mbku(ji,jj)          ;   ikv  = mbkv(ji,jj)             ! last ocean level (u- & v-points)
                zdit = gtsu(ji,jj,jp_tem)   ;   zdjt = gtsv(ji,jj,jp_tem)      ! i- & j-gradient of Temperature
@@ -427,5 +427,5 @@
 
       DO kp = 0, 1                            !==  unmasked before density i- j-, k-gradients  ==!
-         DO_3D_11_11( 1, jpkm1 )
+         DO_3D( 1, 1, 1, 1, 1, jpkm1 )
             IF( jk+kp > 1 ) THEN        ! k-gradient of T & S a jk+kp
                zdkt = ( ts(ji,jj,jk+kp-1,jp_tem,Kbb) - ts(ji,jj,jk+kp,jp_tem,Kbb) )
@@ -442,5 +442,5 @@
       END DO
       !
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
          jk = MIN( nmln(ji,jj), mbkt(ji,jj) ) + 1     ! MIN in case ML depth is the ocean depth
          z1_mlbw(ji,jj) = 1._wp / gdepw(ji,jj,jk,Kmm)
@@ -462,5 +462,5 @@
       DO jl = 0, 1                            ! calculate slope of the 4 triads immediately ONE level below mixed-layer base
          DO kp = 0, 1                         ! with only the slope-max limit   and   MASKED
-            DO_2D_10_10
+            DO_2D( 1, 0, 1, 0 )
                ip = jl   ;   jp = jl
                !
@@ -499,5 +499,5 @@
                ! Must mask contribution to slope from dz/dx at constant s for triads jk=1,kp=0 that poke up though ocean surface
                znot_thru_surface = REAL( 1-1/(jk+kp), wp )  !jk+kp=1,=0.; otherwise=1.0
-               DO_2D_10_10
+               DO_2D( 1, 0, 1, 0 )
                   !
                   ! Calculate slope relative to geopotentials used for GM skew fluxes
@@ -628,5 +628,5 @@
       !
       !                                            !==   surface mixed layer mask   !
-      DO_3D_11_11( 1, jpk )
+      DO_3D( 1, 1, 1, 1, 1, jpk )
          ik = nmln(ji,jj) - 1
          IF( jk <= ik ) THEN   ;   omlmask(ji,jj,jk) = 1._wp
@@ -646,5 +646,5 @@
       !-----------------------------------------------------------------------
       !
-      DO_2D_00_00
+      DO_2D( 0, 0, 0, 0 )
          !                        !==   Slope at u- & v-points just below the Mixed Layer   ==!
          !
Index: /NEMO/trunk/src/OCE/LDF/ldftra.F90
===================================================================
--- /NEMO/trunk/src/OCE/LDF/ldftra.F90	(revision 13294)
+++ /NEMO/trunk/src/OCE/LDF/ldftra.F90	(revision 13295)
@@ -430,5 +430,5 @@
          zaht_min = 0.2_wp * aht0                                       ! minimum value for aht
          zDaht    = aht0 - zaht_min                                      
-         DO_2D_11_11
+         DO_2D( 1, 1, 1, 1 )
             !!gm CAUTION : here we assume lat/lon grid in 20deg N/S band (like all ORCA cfg)
             !!     ==>>>   The Coriolis value is identical for t- & u_points, and for v- and f-points
@@ -648,5 +648,5 @@
       !                       ! Compute lateral diffusive coefficient at T-point
       IF( ln_traldf_triad ) THEN
-         DO_3D_00_00( 1, jpk )
+         DO_3D( 0, 0, 0, 0, 1, jpk )
             ! Take the max of N^2 and zero then take the vertical sum 
             ! of the square root of the resulting N^2 ( required to compute 
@@ -662,5 +662,5 @@
          END_3D
       ELSE
-         DO_3D_00_00( 1, jpk )
+         DO_3D( 0, 0, 0, 0, 1, jpk )
             ! Take the max of N^2 and zero then take the vertical sum 
             ! of the square root of the resulting N^2 ( required to compute 
@@ -678,5 +678,5 @@
       ENDIF
 
-      DO_2D_00_00
+      DO_2D( 0, 0, 0, 0 )
          zfw = MAX( ABS( 2. * omega * SIN( rad * gphit(ji,jj) ) ) , 1.e-10 )
          ! Rossby radius at w-point taken betwenn 2 km and  40km
@@ -688,5 +688,5 @@
       !                                         !==  Bound on eiv coeff.  ==!
       z1_f20 = 1._wp / (  2._wp * omega * sin( rad * 20._wp )  )
-      DO_2D_00_00
+      DO_2D( 0, 0, 0, 0 )
          zzaei = MIN( 1._wp, ABS( ff_t(ji,jj) * z1_f20 ) ) * zaeiw(ji,jj)     ! tropical decrease
          zaeiw(ji,jj) = MIN( zzaei , paei0 )                                  ! Max value = paei0
@@ -694,5 +694,5 @@
       CALL lbc_lnk( 'ldftra', zaeiw(:,:), 'W', 1.0_wp )       ! lateral boundary condition
       !               
-      DO_2D_00_00
+      DO_2D( 0, 0, 0, 0 )
          paeiu(ji,jj,1) = 0.5_wp * ( zaeiw(ji,jj) + zaeiw(ji+1,jj  ) ) * umask(ji,jj,1)
          paeiv(ji,jj,1) = 0.5_wp * ( zaeiw(ji,jj) + zaeiw(ji  ,jj+1) ) * vmask(ji,jj,1)
@@ -750,5 +750,5 @@
       zpsi_uw(:,:,jpk) = 0._wp   ;   zpsi_vw(:,:,jpk) = 0._wp
       !
-      DO_3D_10_10( 2, jpkm1 )
+      DO_3D( 1, 0, 1, 0, 2, jpkm1 )
          zpsi_uw(ji,jj,jk) = - r1_4 * e2u(ji,jj) * ( wslpi(ji,jj,jk  ) + wslpi(ji+1,jj,jk) )   &
             &                                    * ( aeiu (ji,jj,jk-1) + aeiu (ji  ,jj,jk) ) * wumask(ji,jj,jk)
@@ -757,9 +757,9 @@
       END_3D
       !
-      DO_3D_10_10( 1, jpkm1 )
+      DO_3D( 1, 0, 1, 0, 1, jpkm1 )
          pu(ji,jj,jk) = pu(ji,jj,jk) - ( zpsi_uw(ji,jj,jk) - zpsi_uw(ji,jj,jk+1) )
          pv(ji,jj,jk) = pv(ji,jj,jk) - ( zpsi_vw(ji,jj,jk) - zpsi_vw(ji,jj,jk+1) )
       END_3D
-      DO_3D_00_00( 1, jpkm1 )
+      DO_3D( 0, 0, 0, 0, 1, jpkm1 )
          pw(ji,jj,jk) = pw(ji,jj,jk) + (  zpsi_uw(ji,jj,jk) - zpsi_uw(ji-1,jj  ,jk)   &
             &                             + zpsi_vw(ji,jj,jk) - zpsi_vw(ji  ,jj-1,jk) )
@@ -813,5 +813,5 @@
       CALL iom_put( "voce_eiv", zw3d )
       !
-      DO_3D_00_00( 1, jpkm1 )
+      DO_3D( 0, 0, 0, 0, 1, jpkm1 )
          zw3d(ji,jj,jk) = (  psi_vw(ji,jj,jk) - psi_vw(ji  ,jj-1,jk)    &
             &              + psi_uw(ji,jj,jk) - psi_uw(ji-1,jj  ,jk)  ) / e1e2t(ji,jj)
@@ -840,5 +840,5 @@
         zw2d(:,:)   = 0._wp 
         zw3d(:,:,:) = 0._wp 
-        DO_3D_00_00( 1, jpkm1 )
+        DO_3D( 0, 0, 0, 0, 1, jpkm1 )
            zw3d(ji,jj,jk) = zw3d(ji,jj,jk) + ( psi_uw(ji,jj,jk+1)          - psi_uw(ji  ,jj,jk)            )   &
               &                            * ( ts    (ji,jj,jk,jp_tem,Kmm) + ts    (ji+1,jj,jk,jp_tem,Kmm) ) 
@@ -861,5 +861,5 @@
       zw2d(:,:)   = 0._wp 
       zw3d(:,:,:) = 0._wp 
-      DO_3D_00_00( 1, jpkm1 )
+      DO_3D( 0, 0, 0, 0, 1, jpkm1 )
          zw3d(ji,jj,jk) = zw3d(ji,jj,jk) + ( psi_vw(ji,jj,jk+1)          - psi_vw(ji,jj  ,jk)            )   &
             &                            * ( ts    (ji,jj,jk,jp_tem,Kmm) + ts    (ji,jj+1,jk,jp_tem,Kmm) ) 
@@ -876,5 +876,5 @@
         zw2d(:,:) = 0._wp 
         zw3d(:,:,:) = 0._wp 
-        DO_3D_00_00( 1, jpkm1 )
+        DO_3D( 0, 0, 0, 0, 1, jpkm1 )
            zw3d(ji,jj,jk) = zw3d(ji,jj,jk) * ( psi_uw(ji,jj,jk+1)          - psi_uw(ji  ,jj,jk)            )   &
               &                            * ( ts    (ji,jj,jk,jp_sal,Kmm) + ts    (ji+1,jj,jk,jp_sal,Kmm) ) 
@@ -888,5 +888,5 @@
       zw2d(:,:) = 0._wp 
       zw3d(:,:,:) = 0._wp 
-      DO_3D_00_00( 1, jpkm1 )
+      DO_3D( 0, 0, 0, 0, 1, jpkm1 )
          zw3d(ji,jj,jk) = zw3d(ji,jj,jk) + ( psi_vw(ji,jj,jk+1)          - psi_vw(ji,jj  ,jk)            )   &
             &                            * ( ts    (ji,jj,jk,jp_sal,Kmm) + ts    (ji,jj+1,jk,jp_sal,Kmm) ) 
Index: /NEMO/trunk/src/OCE/OBS/obs_oper.F90
===================================================================
--- /NEMO/trunk/src/OCE/OBS/obs_oper.F90	(revision 13294)
+++ /NEMO/trunk/src/OCE/OBS/obs_oper.F90	(revision 13295)
@@ -189,5 +189,5 @@
          ! Initialize daily mean for first timestep of the day
          IF ( idayend == 1 .OR. kt == 0 ) THEN
-            DO_3D_11_11( 1, jpk )
+            DO_3D( 1, 1, 1, 1, 1, jpk )
                prodatqc%vdmean(ji,jj,jk,1) = 0.0
                prodatqc%vdmean(ji,jj,jk,2) = 0.0
@@ -195,5 +195,5 @@
          ENDIF
 
-         DO_3D_11_11( 1, jpk )
+         DO_3D( 1, 1, 1, 1, 1, jpk )
             ! Increment field 1 for computing daily mean
             prodatqc%vdmean(ji,jj,jk,1) = prodatqc%vdmean(ji,jj,jk,1) &
@@ -209,5 +209,5 @@
             IF (lwp) WRITE(numout,*) 'Calculating prodatqc%vdmean on time-step: ',kt
             CALL FLUSH(numout)
-            DO_3D_11_11( 1, jpk )
+            DO_3D( 1, 1, 1, 1, 1, jpk )
                prodatqc%vdmean(ji,jj,jk,1) = prodatqc%vdmean(ji,jj,jk,1) &
                   &                        * zdaystp
@@ -750,5 +750,5 @@
          ! Initialize night-time mean for first timestep of the day
          IF ( idayend == 1 .OR. kt == 0 ) THEN
-            DO_2D_11_11
+            DO_2D( 1, 1, 1, 1 )
                surfdataqc%vdmean(ji,jj) = 0.0
                zmeanday(ji,jj) = 0.0
@@ -761,5 +761,5 @@
          imask_night(:,:) = INT( zouttmp(:,:) )
 
-         DO_2D_11_11
+         DO_2D( 1, 1, 1, 1 )
             ! Increment the temperature field for computing night mean and counter
             surfdataqc%vdmean(ji,jj) = surfdataqc%vdmean(ji,jj)  &
@@ -773,5 +773,5 @@
          IF ( idayend == 0 ) THEN
             IF (lwp) WRITE(numout,*) 'Calculating surfdataqc%vdmean on time-step: ',kt
-            DO_2D_11_11
+            DO_2D( 1, 1, 1, 1 )
                ! Test if "no night" point
                IF ( icount_night(ji,jj) > 0 ) THEN
Index: /NEMO/trunk/src/OCE/OBS/obs_readmdt.F90
===================================================================
--- /NEMO/trunk/src/OCE/OBS/obs_readmdt.F90	(revision 13294)
+++ /NEMO/trunk/src/OCE/OBS/obs_readmdt.F90	(revision 13295)
@@ -215,5 +215,5 @@
       zeta2 = 0.0
 
-      DO_2D_11_11
+      DO_2D( 1, 1, 1, 1 )
        zdxdy = e1e2t(ji,jj) * zpromsk(ji,jj)
        zarea = zarea + zdxdy
Index: /NEMO/trunk/src/OCE/SBC/cyclone.F90
===================================================================
--- /NEMO/trunk/src/OCE/SBC/cyclone.F90	(revision 13294)
+++ /NEMO/trunk/src/OCE/SBC/cyclone.F90	(revision 13295)
@@ -147,5 +147,5 @@
             zb = 2.
 
-            DO_2D_11_11
+            DO_2D( 1, 1, 1, 1 )
 
                ! calc distance between TC center and any point following great circle
@@ -208,5 +208,5 @@
             ENDIF           
         
-            DO_2D_11_11
+            DO_2D( 1, 1, 1, 1 )
                                
                zzrglam = rad * glamt(ji,jj) - zrlon
Index: /NEMO/trunk/src/OCE/SBC/fldread.F90
===================================================================
--- /NEMO/trunk/src/OCE/SBC/fldread.F90	(revision 13294)
+++ /NEMO/trunk/src/OCE/SBC/fldread.F90	(revision 13295)
@@ -1169,5 +1169,5 @@
             WRITE(clname,'(a3,i2.2)') 'src',jn
             CALL iom_get ( inum, jpdom_global, clname, data_tmp(:,:), cd_type = 'Z' )   !  no call to lbc_lnk
-            DO_2D_00_00
+            DO_2D( 0, 0, 0, 0 )
                isrc = NINT(data_tmp(ji,jj)) - 1
                ref_wgts(nxt_wgt)%data_jpi(ji,jj,jn) = 1 + MOD(isrc,  ref_wgts(nxt_wgt)%ddims(1))
@@ -1179,5 +1179,5 @@
             WRITE(clname,'(a3,i2.2)') 'wgt',jn
             CALL iom_get ( inum, jpdom_global, clname, data_tmp(:,:), cd_type = 'Z' )   !  no call to lbc_lnk
-            DO_2D_00_00
+            DO_2D( 0, 0, 0, 0 )
                ref_wgts(nxt_wgt)%data_wgt(ji,jj,jn) = data_tmp(ji,jj)
             END_2D
@@ -1442,5 +1442,5 @@
       dta(:,:,:) = 0._wp
       DO jn = 1,4
-         DO_3D_00_00( 1,ipk )
+         DO_3D( 0, 0, 0, 0, 1,ipk )
             ni = ref_wgts(kw)%data_jpi(ji,jj,jn) + 1
             nj = ref_wgts(kw)%data_jpj(ji,jj,jn) + 1
@@ -1486,5 +1486,5 @@
          !
 !!$         DO jn = 1,4
-!!$            DO_3D_00_00( 1,ipk )
+!!$            DO_3D( 0, 0, 0, 0, 1,ipk )
 !!$               ni = ref_wgts(kw)%data_jpi(ji,jj,jn) + 1
 !!$               nj = ref_wgts(kw)%data_jpj(ji,jj,jn) + 1
@@ -1504,5 +1504,5 @@
          !
          DO jn = 1,4
-            DO_3D_00_00( 1,ipk )
+            DO_3D( 0, 0, 0, 0, 1,ipk )
                ni = ref_wgts(kw)%data_jpi(ji,jj,jn)
                nj = ref_wgts(kw)%data_jpj(ji,jj,jn)
@@ -1513,5 +1513,5 @@
          END DO
          DO jn = 1,4
-            DO_3D_00_00( 1,ipk )
+            DO_3D( 0, 0, 0, 0, 1,ipk )
                ni = ref_wgts(kw)%data_jpi(ji,jj,jn)
                nj = ref_wgts(kw)%data_jpj(ji,jj,jn)
@@ -1522,5 +1522,5 @@
          END DO
          DO jn = 1,4
-            DO_3D_00_00( 1,ipk )
+            DO_3D( 0, 0, 0, 0, 1,ipk )
                ni = ref_wgts(kw)%data_jpi(ji,jj,jn)
                nj = ref_wgts(kw)%data_jpj(ji,jj,jn)
Index: /NEMO/trunk/src/OCE/SBC/geo2ocean.F90
===================================================================
--- /NEMO/trunk/src/OCE/SBC/geo2ocean.F90	(revision 13294)
+++ /NEMO/trunk/src/OCE/SBC/geo2ocean.F90	(revision 13295)
@@ -160,5 +160,5 @@
       ! (computation done on the north stereographic polar plane)
       !
-      DO_2D_00_01
+      DO_2D( 0, 0, 0, 1 )
          !                  
          zlam = plamt(ji,jj)     ! north pole direction & modulous (at t-point)
@@ -249,5 +249,5 @@
       ! =============== !
 
-      DO_2D_00_01
+      DO_2D( 0, 0, 0, 1 )
          IF( MOD( ABS( plamv(ji,jj) - plamv(ji,jj-1) ), 360. ) < 1.e-8 ) THEN
             gsint(ji,jj) = 0.
Index: /NEMO/trunk/src/OCE/SBC/sbc_oce.F90
===================================================================
--- /NEMO/trunk/src/OCE/SBC/sbc_oce.F90	(revision 13294)
+++ /NEMO/trunk/src/OCE/SBC/sbc_oce.F90	(revision 13295)
@@ -217,5 +217,5 @@
       !!---------------------------------------------------------------------
       zcoef = 0.5 / ( zrhoa * zcdrag )
-      DO_2D_00_00
+      DO_2D( 0, 0, 0, 0 )
          ztx = utau(ji-1,jj  ) + utau(ji,jj)
          zty = vtau(ji  ,jj-1) + vtau(ji,jj)
